# ===========================================================================
# Copyright (C) 2006 Ancient World Mapping Center
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
# 
# About Pleiades
# --------------
#
# Pleiades is an international research network and associated web portal and
# content management system devoted to the study of ancient geography. 
#
# See http://icon.stoa.org/trac/pleiades/wiki.
#
# Funding for the creation of this software was provided by a grant from the 
# U.S. National Endowment for the Humanities (http://www.neh.gov).
# ===========================================================================

from Products.CMFCore.DirectoryView import registerDirectory, addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.permissions import ManagePortal

from cStringIO import StringIO

from Products.PleiadesGeocoder import skin_globals
from Products.PleiadesGeocoder import product_name
from Products.PleiadesGeocoder import utils

skinFolders = ('PleiadesGeocoder',)

def install_tools(self, out):
    if not hasattr(self, 'portal_geocoder'):
        addTool = self.manage_addProduct['PleiadesGeocoder'].manage_addTool
        addTool(product_name)

def install_memberdata(self, out):
    utils.addSpatialMemberData(self)

def install_markers(self, out):
    utils.markPortalMembersFolder(self)
    
def setupSkin(self, out):
    skinsTool = getToolByName(self, 'portal_skins')
    registerDirectory('skins', skin_globals)
    addDirectoryViews(skinsTool, 'skins', skin_globals)
    utils.addPleiadesGeocoderSkin(self)
    out.write("Added directory views to portal_skins.\n")

def removeSkin(self, out):
    skinsTool = getToolByName(self, 'portal_skins')
       
def install (self):
    out = StringIO()
    install_tools(self, out)
    install_memberdata(self, out)
    install_markers(self, out)
    setupSkin(self, out)
    out.write('Installation completed.\n')
    return out.getvalue()

def uninstall (self):
    out = StringIO()
    removeSkin(self, out)
    out.write('Uninstallation completed.\n')
    return out.getvalue()
